/*
  Basic type definitions
  Copyright (C) 1999  Hardy Kahl

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

// ----------------------------------------------------------------------------
//  Description      : Basic type definitions.
// ----------------------------------------------------------------------------
//  Remarks          :
//    Hardy     12.11.1998      nobody should change this file, except the
//                              whole team decides.
// ----------------------------------------------------------------------------
//  Modifications    :
//    Hardy     12.11.1998      created this file.
// ----------------------------------------------------------------------------




#ifndef BASE_H
#define BASE_H




#define YES             1
#define NO              0
#define ON              1
#define OFF             0
#define TRUE            1
#define FALSE           0

#define PI              3.141592653589793285
#define EULER           2.718281828
#define GRAVITY         9.8065          // m/s^2
#define UNIVGRAVITY     6.673e-11       // m^3/kg s^2
#define ZERO            0               // K
#define EPSILON0        8.8542e-12      // F/m
#define MU0             1.2566e-6       // H/m
#define LIGHTSPEED      2.9972e8        // m/s
#define PLANCK          6.6261e-34      // Js
#define EVIL            666             // Kloecki

#define forever         for (;;)




// Nomenclature typedefs ------------------------------------------------------
typedef unsigned char   TBool;

typedef unsigned char   TPositionB;
typedef unsigned short  TPositionW;
typedef unsigned long   TPositionD;
typedef unsigned        TPosition;

typedef signed char     TDeltaB;
typedef signed short    TDeltaW;
typedef signed long     TDeltaD;
typedef signed          TDelta;

typedef unsigned char   TSizeB;
typedef unsigned short  TSizeW;
typedef unsigned long   TSizeD;
typedef unsigned        TSize;

typedef unsigned char   TIndexB;
typedef unsigned short  TIndexW;
typedef unsigned long   TIndexD;
typedef unsigned        TIndex;

typedef unsigned char   TCountB;
typedef unsigned short  TCountW;
typedef unsigned long   TCountD;
typedef unsigned        TCount;

typedef unsigned char   TBitFieldB;
typedef unsigned short  TBitFieldW;
typedef unsigned long   TBitFieldD;
typedef unsigned        TBitField;

typedef unsigned char   TByte;
typedef unsigned short  TWord;
typedef unsigned long   TDWord;




// New basic types ------------------------------------------------------------
enum ERelation          {
  RBelow = -2,RSlightlyBelow = -1,
  REqual = 0,
  RSlightlyAbove = 1,RAbove = 2
};




#endif
