/*
  This file contains all typs used by more the one object of the compiler module
  Copyright (C) 1999  Hardy Kahl

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

// ---------------------------------------------------------------------------- 
//  Description      : This file contains all typs used by more the one object
//                     of the compiler module
// ---------------------------------------------------------------------------- 
//  Creation	     :
// ---------------------------------------------------------------------------- 
//  Remarks          : 
// ---------------------------------------------------------------------------- 
//  Modifications    : 	
// ---------------------------------------------------------------------------- 



#ifndef COMMONTYPE_H
#define COMMONTYPE_H



#include "ctlist.h"
#include "xstring.h"



struct xIdentifier;
struct xCommand;
struct xFunction;
struct xExpression;
struct xNode;



typedef xList <xExpression *> xExpressionList;
typedef xList <xIdentifier *> xIdentifierList;
typedef xIdentifierList xArgList;
typedef xList <xCommand *>    xCommandList;
typedef xList <xFunction *>   xFunctionList;


typedef xList           <xExpressionList *>  List_Of_ExpressionLists;
typedef xList           <xIdentifierList *>  List_Of_IdentifierLists;
typedef xList           <xFunctionList   *>  List_Of_FunctionLists;
typedef xList           <xCommandList    *>  List_Of_CommandLists;
typedef xSearchableList <xNode           *>  List_Of_Nodes;


enum EStatus
{
  OK,
  Error
};




enum ESide
{
  Left,
  Right
};




enum EVarType
{
  Unknown,
  Function,
  Simple,
  Array
};




struct xAddressData
{
  xAddressData(){};
  xAddressData(xString name, xString address)
    {
      Name=name; 
      Address=address;
    };
  xString Name;
  xString Address;
};




typedef xList <xAddressData *> xSymboltable;
typedef xList <xString> xAddresslist;




#endif
