/*
  Definition for RAMC to byte code compiler.
  Copyright (C) 1999  Hardy Kahl

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

// ----------------------------------------------------------------------------
//  Description      : Definition for RAMC to byte code compiler.
// ----------------------------------------------------------------------------
//  Remarks          :
//    Hardy     18.11.1998      nobody should change this file, except the
//                              whole team decides.
// ----------------------------------------------------------------------------
//  Modifications    :
//    Hardy     18.11.1998      created this file.
//    Hardy     25.03.1999      added command "STOP".
//                              fixed line problem in "xRAMCompilerException".
// ----------------------------------------------------------------------------




#ifndef COMPRAM_H
#define COMPRAM_H




#include "prgram.h"
#include "prgbc.h"
#include "exbase.h"




// possible errors while execution : ------------------------------------------
#define ECRCC_INVALID_CODE      0
#define ECRCC_INCORRECT_SYNTAX  1




// xRAMCompilerException ------------------------------------------------------
struct xRAMCompilerException : public xBaseException {
  xRAMCompilerException(TErrorCode error, TIndex line);
  virtual char *GetText() const;
};




// RAM compiler : -------------------------------------------------------------
void CompileRAM2BC(xRAMProgram &source, xBCProgram &destination);




#endif
