/*
  Container base
  Copyright (C) 1999  Hardy Kahl

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

// ----------------------------------------------------------------------------
//  Description      : Container base
// ----------------------------------------------------------------------------
//  Remarks          : none.
//
// ----------------------------------------------------------------------------
//  (c) Copyright 1996 by iXiONmedia, all rights reserved.
// ----------------------------------------------------------------------------




#ifndef CTBASE_H
#define CTBASE_H




#include "exbase.h"
#include "numeric.h"




// Container class error codes ------------------------------------------------
#define ECCT_INDEX              0
#define ECCT_RESIZE             1
#define ECCT_NOTFOUND           2




// xContainerException --------------------------------------------------------
struct xContainerException : public xBaseException {
  xContainerException(TErrorCode error,char const *info = 0,char *module = 0,
    TIndexD line = 0)
    : xBaseException(error,info,module,line,"CT")
    { }
  virtual char *GetText() const;
};




// xContainer -----------------------------------------------------------------
template <class T>
class xContainer {
  public:
  xContainer()
    { };
  virtual ~xContainer()
    { };

  protected:
  virtual void Create(T &object)
    { }
  virtual void Kill(T &object)
    { }
};




// xComparator ----------------------------------------------------------------
template <class T>
class xComparator {
  protected:
  virtual ERelation Compare(T &object, T &refobject)
    { return NUM_COMPARE(object, refobject); }
};




#endif
