/*
  Generic Exceptions
  Copyright (C) 1999  Hardy Kahl

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

// ----------------------------------------------------------------------------
//  Description      : Generic exceptions
// ----------------------------------------------------------------------------
//  Remarks          : none.
//
// ----------------------------------------------------------------------------
//  (c) Copyright 1996 by iXiONmedia, all rights reserved.
// ----------------------------------------------------------------------------




#ifndef EXGEN_H
#define EXGEN_H




#include "exbase.h"




// Error codes ----------------------------------------------------------------
#define EC_CANNOTEVALUATE               0
#define EC_NOTYETIMPLEMENTED            1
#define EC_ERROR                        2
#define EC_NULLPOINTER                  3
#define EC_INVALIDPAR			4
#define EC_INDEX			5
#define EC_BUFFEROVERFLOW               6
#define EC_BUFFERUNDERFLOW              7
#define EC_ITEMNOTFOUND                 8
#define EC_INVALIDOP                    9

#define ECMEM_GENERAL                   0
#define ECMEM_CONVENTIONAL              1
#define ECMEM_EXTENDED                  2
#define ECMEM_EMS                       3
#define ECMEM_SWAP                      4



// Throw macro ----------------------------------------------------------------
#define EX_THROWMEM(BYTES)\
  throw xMemoryException(ECMEM_GENERAL,BYTES,__FILE__,__LINE__);
#define EX_MEMCHECK(PTR)\
  if (!PTR) throw xMemoryException(ECMEM_GENERAL,sizeof(*PTR),__FILE__,__LINE__);




// xGenericException ----------------------------------------------------------
struct xGenericException : public xBaseException {
  xGenericException(TErrorCode error,char const *info = 0,char *module = 0,
    TIndexD line = 0)
    : xBaseException(error,info,module,line,"GEN")
    { }
  virtual char *GetText() const;
};

// xMemoryException -----------------------------------------------------------
struct xMemoryException : public xBaseException {
  xMemoryException(TErrorCode error,TSizeD bytesmissing = 0,char *module = 0,
    TIndexD line = 0);
  virtual char *GetText() const;
};




#endif
