/*
  Definition of xVisitor
  Copyright (C) 1999  Hardy Kahl

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

// ---------------------------------------------------------------------------- 
//  Description      : Definition of xVistor.
//                     xVisitor is an abstract object being an ancestor of
//                     xPascallinoVisitor an xPascalliVisitor.
// ---------------------------------------------------------------------------- 
//  Creation	     : 24.6.1999
// ---------------------------------------------------------------------------- 
//  Remarks          : 
// ---------------------------------------------------------------------------- 
//  Modifications    : 
//	
// ---------------------------------------------------------------------------- 




#ifndef VISITOR_H
#define VISITOR_H




//#include "commontypes.h"
//#include "prgcplx.h"
#include "xstring.h"
#include <iostream.h>
#include <fstream.h>



struct xNode;




template <class TProgram, class TMemManager>
class xVisitor
{
 public:
  xVisitor(){};
  virtual ~xVisitor(){};
 protected:
  xString FileName;
  TProgram Program;
  TMemManager MemManager;
  virtual void write_ProgramToFile();
};




template <class TProgram, class TMemManager> 
void xVisitor<TProgram,TMemManager>::write_ProgramToFile()
{
  cout << "Program will be written to disk" << endl;
  ofstream stream(FileName);
  stream << Program;
};



#endif
