/*
  set definitions
  Copyright (C) 1999  Hardy Kahl

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

// ----------------------------------------------------------------------------
//  Description      : set definitions.
// ----------------------------------------------------------------------------
//  Remarks          :
//    Hardy     09.12.1998      nobody should change this file, except the
//                              whole team decides.
// ----------------------------------------------------------------------------
//  Modifications    :
//    Hardy     09.12.1998      created this file.
//    Hardy     26.03.1999      fixed bug in Contains(T &object, TIndex &index)
//                                (constant index).
// ----------------------------------------------------------------------------




#ifndef XSET_H
#define XSET_H




#include "base.h"
#include "ctbase.h"
#include "ctlist.h"




template <class T>
struct xSet : public xList<T> {
  inline TIndex operator+=(T object);
  inline void operator-=(T object);
  inline TIndex operator()(T object);
  inline TBool Contains(T object);
  inline TBool Contains(T object, TIndex &index);
};




template <class T>
TIndex xSet<T>::operator+=(T object)
{
  TIndex index;
  if (Contains(object, index)) return index;
  else return InternalInsert(Items, object);
}




template <class T>
void xSet<T>::operator-=(T object)
{
  TIndex index;
  if (Contains(object, index)) xList<T>::operator-=(index);
}




template <class T>
TIndex xSet<T>::operator()(T object)
{
  for (TIndex i = 0; i<Items; i++)
    if (object == List[i]) return i;
  throw xContainerException(ECCT_NOTFOUND);
}




template <class T>
TBool xSet<T>::Contains(T object)
{
  TIndex index;
  return Contains(object, index);
}




template <class T>
TBool xSet<T>::Contains(T object, TIndex &index)
{
  for (TIndex i = 0; i<Items; i++)
    if (object == List[i]) {
      index = i;
      return TRUE;
    }
  return FALSE;
}




#endif
