/*
  plic symboltable
  Copyright (C) 1999  Hardy Kahl

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "base.h"
#include "xstring.h"
#include "xset.h"
#include "frontend.h"


// overloading of xSet for xIdentifier

struct xIdentifierSet : public xSet<xIdentifier *> 
{
  inline TIndex operator+=(xIdentifier *object);
  inline void operator-=(xIdentifier *object);
  inline TIndex operator()(xIdentifier *object);
  inline TBool Contains(xIdentifier *object);
  inline TBool Contains(xIdentifier *object, TIndex &index);
};


TIndex xIdentifierSet::operator+=(xIdentifier *object)
{
  TIndex index;
  if (Contains(object, index)) return index;
  else return InternalInsert(Items, object);
}


void xIdentifierSet::operator-=(xIdentifier *object)
{
  TIndex index;
  if (Contains(object, index)) xList<xIdentifier *>::operator-=(index);
}


TIndex xIdentifierSet::operator()(xIdentifier *object)
{
  for (TIndex i = 0; i<Items; i++)
    if (*object == *List[i]) return i;
  throw xContainerException(ECCT_NOTFOUND);
}



TBool xIdentifierSet::Contains(xIdentifier *object)
{
  TIndex index;
  return Contains(object, index);
}



TBool xIdentifierSet::Contains(xIdentifier *object, TIndex &index)
{
  for (TIndex i = 0; i<Items; i++)
    if (*object == *List[i]) {
      index = i;
      return TRUE;
    }
  return FALSE;
}










